diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java
new file mode 100644
index 000000000..c1fc9e3b2
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java
@@ -0,0 +1,134 @@
+package net.minecraft.client.render.entity;
+
+import net.minecraft.client.entity.player.PlayerLocal;
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.item.model.ItemModelDispatcher;
+import net.minecraft.client.render.model.ModelBiped;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.entity.IArmorWearing;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.enums.HumanArmorShape;
+import net.minecraft.core.item.*;
+import org.jetbrains.annotations.Nullable;
+import org.lwjgl.opengl.GL11;
+
+public class MobRendererBipedArmored<T extends Mob & IArmorWearing<HumanArmorShape>> extends MobRendererBiped<T> {
+    protected ModelBiped modelArmorA;
+    protected ModelBiped modelArmorB;
+
+    public MobRendererBipedArmored(ModelBiped model, float shadowSize) {
+        this(model, new ModelBiped(1.0F), new ModelBiped(0.5f), shadowSize);
+    }
+
+    public MobRendererBipedArmored(ModelBiped model, ModelBiped modelArmorA, ModelBiped modelArmorB, float shadowSize) {
+        super(model, shadowSize);
+
+        this.modelArmorA = modelArmorA;
+        this.modelArmorB = modelArmorB;
+    }
+
+    @Override
+    protected void renderAdditional(T entity, float f) {
+        final @Nullable ItemStack stack = entity.getItemInArmorSlot(HumanArmorShape.HEAD);
+        if(stack != null) {
+            GL11.glPushMatrix();
+            this.modelBipedMain.head.translateTo(0.0625F);
+            if(stack.itemID < Blocks.blocksList.length && BlockModelDispatcher.getInstance().getDispatch(Blocks.getBlock(stack.itemID)).shouldItemRender3d())
+            {
+                float scale = 0.625F;
+                GL11.glTranslatef(0.0F, -0.25F, 0.0F);
+                GL11.glRotatef(180F, 0.0F, 1.0F, 0.0F);
+                GL11.glScalef(scale, -scale, scale);
+                ItemModelDispatcher.getInstance().getDispatch(stack).renderItem(Tessellator.instance, renderDispatcher.itemRenderer, entity, stack);
+            } else if (!(stack.getItem() instanceof IArmorItem)) {
+                GL11.glEnable(GL11.GL_CULL_FACE);
+                float scale = 0.625F;
+                GL11.glTranslatef(0.0F, -0.8F, 0.0F);
+                GL11.glRotatef(180, 0.0F, 0.0F, 1.0F);
+                GL11.glScalef(scale, scale, scale);
+                ItemModelDispatcher.getInstance().getDispatch(stack).renderItemInWorld(Tessellator.instance, entity, stack, entity.getBrightness(f), 1f, true);
+                GL11.glDisable(GL11.GL_CULL_FACE);
+            }
+            GL11.glPopMatrix();
+        }
+
+        super.renderAdditional(entity, f);
+    }
+
+    @Override
+    public void render(Tessellator tessellator, T entity, double x, double y, double z, float yaw, float partialTick) {
+        GL11.glEnable(GL11.GL_BLEND);
+        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+
+        ItemStack itemstack = entity.getHeldItem();
+
+        this.modelArmorA.holdingRightHand = this.modelArmorB.holdingRightHand = this.modelBipedMain.holdingRightHand |= itemstack != null;
+        this.modelArmorA.sneaking = this.modelArmorB.sneaking = this.modelBipedMain.sneaking = entity.isSneaking();
+        this.modelArmorA.isRiding = this.modelArmorB.isRiding = this.modelBipedMain.isRiding = entity.isPassenger();
+
+        double realY = y - (double)entity.heightOffset;
+        if(entity.isSneaking() && !(entity instanceof PlayerLocal)) {
+            realY -= 0.125D;
+        }
+
+        super.render(tessellator, entity, x, realY, z, yaw, partialTick);
+
+        this.modelArmorA.holdingLarge = this.modelArmorB.holdingLarge = this.modelBipedMain.holdingLarge = false;
+        this.modelArmorA.sneaking = this.modelArmorB.sneaking = this.modelBipedMain.sneaking = false;
+        this.modelArmorA.holdingRightHand = this.modelArmorB.holdingRightHand = this.modelBipedMain.holdingRightHand = false;
+        this.modelArmorA.holdingLeftHand = this.modelArmorB.holdingLeftHand = this.modelBipedMain.holdingLeftHand = false;
+
+        GL11.glDisable(GL11.GL_BLEND);
+    }
+
+    @Override
+    protected boolean prepareArmor(T entity, int layer, float partialTick) {
+        ItemStack itemstack = entity.getItemInArmorSlot(HumanArmorShape.values()[(entity.getNumArmorSlots() - 1) - layer]);
+        if(itemstack != null)
+        {
+            Item item = itemstack.getItem();
+            if(item instanceof ItemQuiver)
+            {
+                bindTexture("/assets/minecraft/textures/armor/quiver.png");
+                ModelBiped modelBiped = modelArmorA;
+                modelBiped.body.visible = layer == 1 || layer == 2;
+                setArmorModel(modelBiped);
+                return true;
+            }
+            if(item instanceof ItemQuiverEndless)
+            {
+                bindTexture("/assets/minecraft/textures/armor/quiver_golden.png");
+                ModelBiped modelBiped = modelArmorA;
+                modelBiped.body.visible = layer == 1 || layer == 2;
+                setArmorModel(modelBiped);
+                return true;
+            }
+            if(item == Items.ARMOR_BOOTS_ICESKATES)
+            {
+                bindTexture("/assets/minecraft/textures/armor/skates.png");
+                ModelBiped modelBiped = modelArmorA;
+                modelBiped.legRight.visible = layer == 2 || layer == 3;
+                modelBiped.legLeft.visible = layer == 2 || layer == 3;
+                setArmorModel(modelBiped);
+                return true;
+            }
+            if(item instanceof IArmorItem && ((IArmorItem) item).getArmorMaterial() != null)
+            {
+                IArmorItem armorItem = (IArmorItem)item;
+                bindTexture(String.format("/assets/%s/textures/armor/%s_%d.png", armorItem.getArmorMaterial().identifier.namespace, armorItem.getArmorMaterial().identifier.value, (layer != 2 ? 1 : 2)));
+                ModelBiped modelBiped = layer != 2 ? modelArmorA : modelArmorB;
+                modelBiped.head.visible = layer == 0;
+                modelBiped.hair.visible = layer == 0;
+                modelBiped.body.visible = layer == 1 || layer == 2;
+                modelBiped.armRight.visible = layer == 1;
+                modelBiped.armLeft.visible = layer == 1;
+                modelBiped.legRight.visible = layer == 2 || layer == 3;
+                modelBiped.legLeft.visible = layer == 2 || layer == 3;
+                setArmorModel(modelBiped);
+                return true;
+            }
+        }
+        return false;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererButterfly.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererButterfly.java
new file mode 100644
index 000000000..d782a3b58
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererButterfly.java
@@ -0,0 +1,81 @@
+package net.minecraft.client.render.entity;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.TextureManager;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.entity.animal.MobButterfly;
+import net.minecraft.core.util.helper.MathHelper;
+import org.lwjgl.opengl.GL11;
+import org.lwjgl.opengl.GL12;
+
+import java.util.Random;
+
+public class MobRendererButterfly extends EntityRenderer<MobButterfly> {
+    private static final Random sizeRandom = new Random();
+    @Override
+    public void render(Tessellator tessellator, MobButterfly butterfly, double x, double y, double z, float yaw, float partialTick) {
+        // 0.45 -> 0.8
+        sizeRandom.setSeed((long) butterfly.getSkinVariant() << 16);
+        float scale = 0.45f + (sizeRandom.nextFloat() * 0.35f);
+        float yRot = MathHelper.lerp(butterfly.yRotO, butterfly.yRot, partialTick);
+        drawButterfly(tessellator, butterfly.tickCount, scale, yRot, x, y, z, partialTick, renderDispatcher.textureManager, getTexture(butterfly));
+    }
+
+    @Override
+    public void renderPreview(Tessellator tessellator, MobButterfly butterfly, double x, double y, double z, float yaw, float partialTick) {
+        float yRot = MathHelper.lerp(butterfly.yRotO, butterfly.yRot, partialTick);
+        drawButterfly(tessellator, butterfly.tickCount, 1.25f, -yRot, x, y + 0.5, z, partialTick, renderDispatcher.textureManager, getTexture(butterfly));
+    }
+
+    public static void drawButterfly(Tessellator tessellator, int ticksAlive, float scale, float yRot, double x, double y, double z, float partialTick, TextureManager textureManager, String texture) {
+        textureManager.bindTexture(textureManager.loadTexture(texture));
+        GL11.glPushMatrix();
+        GL11.glTranslatef((float) x, (float) y + 0.25f, (float) z);
+        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+        GL11.glDisable(GL11.GL_CULL_FACE);
+        GL11.glDisable(GL11.GL_LIGHTING);
+        GL11.glScalef(0.5F * scale, 0.5F * scale, 0.5F * scale);
+
+        GL11.glRotatef(yRot, 0, 1, 0);
+
+        GL11.glRotatef(-22.5f, 1, 0, 0);
+
+        float xOff = -0.5F;
+        float zOff = -0.5F;
+
+        float flapAngle = (MathHelper.sin(ticksAlive + partialTick) + 1) * 22.5f + 5;
+
+        GL11.glPushMatrix();
+        GL11.glRotatef(-flapAngle, 0, 0, 1);
+        tessellator.startDrawingQuads();
+        tessellator.addVertexWithUV(xOff,       0.0D, zOff,       0,   1);
+        tessellator.addVertexWithUV(xOff + 0.5, 0.0D, zOff,       0.5, 1);
+        tessellator.addVertexWithUV(xOff + 0.5, 0.0D, zOff + 1.0, 0.5, 0);
+        tessellator.addVertexWithUV(xOff,       0.0D, zOff + 1.0, 0,   0);
+        tessellator.draw();
+        GL11.glPopMatrix();
+
+        GL11.glPushMatrix();
+        GL11.glRotatef(flapAngle, 0, 0, 1);
+        tessellator.startDrawingQuads();
+        tessellator.addVertexWithUV(xOff + 0.5, 0.0D, zOff,       0.5, 1);
+        tessellator.addVertexWithUV(xOff + 1.0, 0.0D, zOff,       1.0, 1);
+        tessellator.addVertexWithUV(xOff + 1.0, 0.0D, zOff + 1.0, 1.0, 0);
+        tessellator.addVertexWithUV(xOff + 0.5, 0.0D, zOff + 1.0, 0.5, 0);
+        tessellator.draw();
+        GL11.glPopMatrix();
+
+        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
+        GL11.glEnable(GL11.GL_CULL_FACE);
+        GL11.glEnable(GL11.GL_LIGHTING);
+        GL11.glPopMatrix();
+    }
+
+    public String getTexture(MobButterfly butterfly) {
+        if (!Minecraft.getMinecraft().gameSettings.mobVariants.value) {
+            return butterfly.getDefaultEntityTexture();
+        } else {
+            return butterfly.getEntityTexture();
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
index da22957f8..c838aa0d5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
@@ -2,7 +2,6 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.Minecraft;
 
-import net.minecraft.client.entity.player.PlayerLocal;
 import net.minecraft.client.render.BlockEntityRenderDispatcher;
 import net.minecraft.client.render.Font;
 import net.minecraft.client.render.Lighting;
@@ -13,30 +12,23 @@ import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.blockentity.TileEntityRenderer;
 import net.minecraft.client.render.camera.EntityCamera;
-import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.model.ModelBiped;
 import net.minecraft.client.render.model.ModelPlayer;
 import net.minecraft.client.render.model.ModelPlayerSlim;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.Global;
-import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.item.*;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.BlocksContainer;
 import org.lwjgl.opengl.GL11;
 
-public class MobRendererPlayer extends MobRenderer<Player>
+public class MobRendererPlayer extends MobRendererBipedArmored<Player>
 {
-    private ModelBiped modelBipedMain;
     private final ModelPlayer modelThick;
     private final ModelPlayer modelSlim;
-    private final ModelBiped modelArmorChestplate;
-    private final ModelBiped modelArmor;
 
     private BlocksContainer container = null;
     private RenderBlocks containerRenderBlock = null;
@@ -44,94 +36,10 @@ public class MobRendererPlayer extends MobRenderer<Player>
     public MobRendererPlayer()
     {
         super(new ModelPlayer(0.0F), 0.5F);
-        modelBipedMain = (ModelBiped)mainModel;
-        modelArmorChestplate = new ModelBiped(1.0F);
-        modelArmor = new ModelBiped(0.5F);
         modelThick = new ModelPlayer(0.0f);
         modelSlim = new ModelPlayerSlim(0.0f);
     }
-    protected void renderSpecials(Player player, float partialTick)
-    {
-        if (Minecraft.getMinecraft().thePlayer.getGamemode() == Gamemode.spectator && player.getGamemode() == Gamemode.spectator){
-            GL11.glColor4f(1f, 1f, 1f, 0.25f);
-        } else if (player.getGamemode() == Gamemode.spectator) {
-            GL11.glColor4f(1f, 1f, 1f, 0.0f);
-        }
-        ItemStack itemstack = player.inventory.armorItemInSlot(IArmorItem.PIECE_HEAD);
-        if(itemstack != null)
-        {
-            GL11.glPushMatrix();
-            modelBipedMain.head.translateTo(0.0625F);
-            if(itemstack.itemID < Blocks.blocksList.length && BlockModelDispatcher.getInstance().getDispatch(Blocks.getBlock(itemstack.itemID)).shouldItemRender3d())
-            {
-                float scale = 0.625F;
-                GL11.glTranslatef(0.0F, -0.25F, 0.0F);
-                GL11.glRotatef(180F, 0.0F, 1.0F, 0.0F);
-                GL11.glScalef(scale, -scale, scale);
-                ItemModelDispatcher.getInstance().getDispatch(itemstack).renderItem(Tessellator.instance, renderDispatcher.itemRenderer, player, itemstack);
-            } else if (!(itemstack.getItem() instanceof IArmorItem)) {
-                GL11.glEnable(GL11.GL_CULL_FACE);
-                float scale = 0.625F;
-                GL11.glTranslatef(0.0F, -0.8F, 0.0F);
-                GL11.glRotatef(180, 0.0F, 0.0F, 1.0F);
-                GL11.glScalef(scale, scale, scale);
-                ItemModelDispatcher.getInstance().getDispatch(itemstack).renderItemInWorld(Tessellator.instance, player, itemstack, player.getBrightness(partialTick), 1f, true);
-                GL11.glDisable(GL11.GL_CULL_FACE);
-            }
-            GL11.glPopMatrix();
-        }
-
-        boolean renderCape = bindDownloadableTexture("https://api.betterthanadventure.net/capes?username=" + player.username, null, null);
-        if (!renderCape)
-        {
-            renderCape = bindDownloadableTexture(player.capeURL, null, null);
-        }
-    	
-    	if(renderCape) {
-            GL11.glPushMatrix();
-            float brightness = (Global.accessor.isFullbrightEnabled() || LightmapHelper.isLightmapEnabled()) ? 1 : player.getBrightness(partialTick);
-            GL11.glColor4f(brightness, brightness, brightness, 1f);
-            GL11.glTranslatef(0.0F, 0.0F, 0.125F);
-            float yawOff = player.yBodyRotO + (player.yBodyRot - player.yBodyRotO) * partialTick;
-            float bodyAngle = 5;
-            if(player.isSneaking())
-            {
-                bodyAngle += 25F;
-            }
-            double _xd = player.xdO + (player.xd - player.xdO) * partialTick;
-            double _yd = Math.min(player.ydO + (player.yd - player.ydO) * partialTick, 0);
-            double _zd = player.zd0 + (player.zd - player.zd0) * partialTick;
-            double vel = -1/(3 * Math.hypot(_xd, _zd) + 1) + 1;
-            double moveAng = Math.atan2(_xd, _zd);
-            double yawRad = Math.toRadians(yawOff);
-            double multiplier = 1 - Math.abs((((Math.cos(yawRad) + 1) - (Math.cos(moveAng) + 1) + 2)/2) -1); // Hell code, basically measures how similar the angle you're facing is to the angle you're moving, with it returning 1 if the same angle and 0 if opposite angles
-            player.wobbleTimer += (float) (((player.tickCount + partialTick) - player.lastRenderTick)/(30 - 29 * MathHelper.clamp(vel, 0, 1)));
-            player.lastRenderTick = player.tickCount;
-            double wobble = Math.sin(player.wobbleTimer) * (1.5 + 4.5 * vel * multiplier);
-            GL11.glRotatef((float) MathHelper.clamp((MathHelper.clamp(bodyAngle + vel * 100 * multiplier, bodyAngle, 100f) + wobble) - _yd * 60, 0, 180), 1.0F, 0.0F, 0.0F);
-            GL11.glRotatef(0, 0.0F, 0.0F, 1.0F);
-            GL11.glRotatef(0, 0.0F, 1.0F, 0.0F);
-            GL11.glRotatef(180F, 0.0F, 1.0F, 0.0F);
-            modelBipedMain.renderCloak(0.0625F);
-            GL11.glPopMatrix();
-    	}
 
-		ItemStack itemstack1 = player.inventory.getCurrentItem();
-		if(itemstack1 != null) {
-            GL11.glPushMatrix();
-            modelBipedMain.armRight.translateTo(0.0625F);
-            BlockModel.setRenderBlocks(renderDispatcher.itemRenderer.renderBlocksInstance);
-            ItemModelDispatcher.getInstance().getDispatch(itemstack1).renderItemThirdPerson(Tessellator.instance, renderDispatcher.itemRenderer, player, itemstack1, true);
-            GL11.glPopMatrix();
-		}
-
-        if (player.getHeldObject() != null) {
-            float walkSpeed = player.walkAnimSpeedO + (player.walkAnimSpeed - player.walkAnimSpeedO) * partialTick;
-            float walkProgress = player.walkAnimPos - player.walkAnimSpeed * (1.0F - partialTick);
-            GL11.glTranslatef(0, MathHelper.cos(walkProgress/2 * 2/3f)/26f * walkSpeed + 0.1f, 0);
-            drawHeldObject(player, partialTick);
-        }
-	}
     public void drawFirstPersonHand(Player player, boolean isLeft)
     {
         mainModel = player.slimModel ? modelSlim : modelThick;
@@ -288,59 +196,57 @@ public class MobRendererPlayer extends MobRenderer<Player>
     }
 
     @Override
-    protected boolean prepareArmor(Player entity, int layer, float partialTick) {
-        ItemStack itemstack = entity.inventory.armorItemInSlot(IArmorItem.PIECE_HEAD - layer);
-        if(itemstack != null)
+    protected void renderAdditional(Player player, float partialTick)
+    {
+        if (Minecraft.getMinecraft().thePlayer.getGamemode() == Gamemode.spectator && player.getGamemode() == Gamemode.spectator){
+            GL11.glColor4f(1f, 1f, 1f, 0.25f);
+        } else if (player.getGamemode() == Gamemode.spectator) {
+            GL11.glColor4f(1f, 1f, 1f, 0.0f);
+        }
+
+        super.renderAdditional(player, partialTick);
+
+        boolean renderCape = bindDownloadableTexture("https://api.betterthanadventure.net/capes?username=" + player.username, null, null);
+        if (!renderCape)
         {
-            Item item = itemstack.getItem();
-            if(item instanceof ItemQuiver)
-            {
-                bindTexture("/assets/minecraft/textures/armor/quiver.png");
-                ModelBiped modelBiped = modelArmorChestplate;
-                modelBiped.body.visible = layer == 1 || layer == 2;
-                setArmorModel(modelBiped);
-                return true;
-            }
-            if(item instanceof ItemQuiverEndless)
-            {
-                bindTexture("/assets/minecraft/textures/armor/quiver_golden.png");
-                ModelBiped modelBiped = modelArmorChestplate;
-                modelBiped.body.visible = layer == 1 || layer == 2;
-                setArmorModel(modelBiped);
-                return true;
-            }
-            if(item == Items.ARMOR_BOOTS_ICESKATES)
-            {
-                bindTexture("/assets/minecraft/textures/armor/skates.png");
-                ModelBiped modelBiped = modelArmorChestplate;
-                modelBiped.legRight.visible = layer == 2 || layer == 3;
-                modelBiped.legLeft.visible = layer == 2 || layer == 3;
-                setArmorModel(modelBiped);
-                return true;
-            }
-            if(item instanceof IArmorItem && ((IArmorItem) item).getArmorMaterial() != null)
+            renderCape = bindDownloadableTexture(player.capeURL, null, null);
+        }
+
+        if(renderCape) {
+            GL11.glPushMatrix();
+            float brightness = (Global.accessor.isFullbrightEnabled() || LightmapHelper.isLightmapEnabled()) ? 1 : player.getBrightness(partialTick);
+            GL11.glColor4f(brightness, brightness, brightness, 1f);
+            GL11.glTranslatef(0.0F, 0.0F, 0.125F);
+            float yawOff = player.yBodyRotO + (player.yBodyRot - player.yBodyRotO) * partialTick;
+            float bodyAngle = 5;
+            if(player.isSneaking())
             {
-                IArmorItem armorItem = (IArmorItem)item;
-                bindTexture(String.format("/assets/%s/textures/armor/%s_%d.png", armorItem.getArmorMaterial().identifier.namespace, armorItem.getArmorMaterial().identifier.value, (layer != 2 ? 1 : 2)));
-                ModelBiped modelBiped = layer != 2 ? modelArmorChestplate : modelArmor;
-                modelBiped.head.visible = layer == 0;
-                modelBiped.hair.visible = layer == 0;
-                modelBiped.body.visible = layer == 1 || layer == 2;
-                modelBiped.armRight.visible = layer == 1;
-                modelBiped.armLeft.visible = layer == 1;
-                modelBiped.legRight.visible = layer == 2 || layer == 3;
-                modelBiped.legLeft.visible = layer == 2 || layer == 3;
-                setArmorModel(modelBiped);
-                return true;
+                bodyAngle += 25F;
             }
+            double _xd = player.xdO + (player.xd - player.xdO) * partialTick;
+            double _yd = Math.min(player.ydO + (player.yd - player.ydO) * partialTick, 0);
+            double _zd = player.zd0 + (player.zd - player.zd0) * partialTick;
+            double vel = -1/(3 * Math.hypot(_xd, _zd) + 1) + 1;
+            double moveAng = Math.atan2(_xd, _zd);
+            double yawRad = Math.toRadians(yawOff);
+            double multiplier = 1 - Math.abs((((Math.cos(yawRad) + 1) - (Math.cos(moveAng) + 1) + 2)/2) -1); // Hell code, basically measures how similar the angle you're facing is to the angle you're moving, with it returning 1 if the same angle and 0 if opposite angles
+            player.wobbleTimer += (float) (((player.tickCount + partialTick) - player.lastRenderTick)/(30 - 29 * MathHelper.clamp(vel, 0, 1)));
+            player.lastRenderTick = player.tickCount;
+            double wobble = Math.sin(player.wobbleTimer) * (1.5 + 4.5 * vel * multiplier);
+            GL11.glRotatef((float) MathHelper.clamp((MathHelper.clamp(bodyAngle + vel * 100 * multiplier, bodyAngle, 100f) + wobble) - _yd * 60, 0, 180), 1.0F, 0.0F, 0.0F);
+            GL11.glRotatef(0, 0.0F, 0.0F, 1.0F);
+            GL11.glRotatef(0, 0.0F, 1.0F, 0.0F);
+            GL11.glRotatef(180F, 0.0F, 1.0F, 0.0F);
+            modelBipedMain.renderCloak(0.0625F);
+            GL11.glPopMatrix();
         }
-        return false;
-    }
 
-    @Override
-    protected void renderAdditional(Player entity, float partialTick)
-    {
-        renderSpecials(entity, partialTick);
+        if (player.getHeldObject() != null) {
+            float walkSpeed = player.walkAnimSpeedO + (player.walkAnimSpeed - player.walkAnimSpeedO) * partialTick;
+            float walkProgress = player.walkAnimPos - player.walkAnimSpeed * (1.0F - partialTick);
+            GL11.glTranslatef(0, MathHelper.cos(walkProgress/2 * 2/3f)/26f * walkSpeed + 0.1f, 0);
+            drawHeldObject(player, partialTick);
+        }
     }
 
     @Override
@@ -373,40 +279,17 @@ public class MobRendererPlayer extends MobRenderer<Player>
     public void render(Tessellator tessellator, Player entity, double x, double y, double z,
                        float yaw, float partialTick)
     {
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glBlendFunc(770, 771);
-        mainModel = entity.slimModel ? modelSlim : modelThick;
-        modelBipedMain = entity.slimModel ? modelSlim : modelThick;
+        this.mainModel = entity.slimModel ? this.modelSlim : this.modelThick;
+        this.modelBipedMain = entity.slimModel ? this.modelSlim : this.modelThick;
+        this.modelArmorA.holdingLarge = this.modelArmorB.holdingLarge = this.modelBipedMain.holdingLarge = entity.getHeldObject() != null;
+        this.modelArmorA.holdingRightHand = this.modelArmorB.holdingRightHand = this.modelBipedMain.holdingRightHand |= entity.getHeldObject() != null;
+        this.modelArmorA.holdingLeftHand = this.modelArmorB.holdingLeftHand = this.modelBipedMain.holdingLeftHand |= entity.getHeldObject() != null;
 
-        ItemStack itemstack = entity.inventory.getCurrentItem();
-        modelArmorChestplate.holdingLarge = modelArmor.holdingLarge = modelBipedMain.holdingLarge = entity.getHeldObject() != null;
-
-        modelArmorChestplate.holdingRightHand = modelArmor.holdingRightHand = modelBipedMain.holdingRightHand = itemstack != null;
-        modelArmorChestplate.holdingRightHand = modelArmor.holdingRightHand = modelBipedMain.holdingRightHand |= entity.getHeldObject() != null;
-        modelArmorChestplate.holdingLeftHand = modelArmor.holdingLeftHand = modelBipedMain.holdingLeftHand |= entity.getHeldObject() != null;
-        modelArmorChestplate.sneaking = modelArmor.sneaking = modelBipedMain.sneaking = entity.isSneaking();
-        modelArmorChestplate.isRiding = modelArmor.isRiding = modelBipedMain.isRiding = entity.isPassenger();
-        double d3 = y - (double)entity.heightOffset;
-        if(entity.isSneaking() && !(entity instanceof PlayerLocal))
-        {
-            d3 -= 0.125D;
-        }
-        super.render(tessellator, entity, x, d3, z, yaw, partialTick);
-        modelArmorChestplate.holdingLarge = modelArmor.holdingLarge = modelBipedMain.holdingLarge = false;
-        modelArmorChestplate.sneaking = modelArmor.sneaking = modelBipedMain.sneaking = false;
-        modelArmorChestplate.holdingRightHand = modelArmor.holdingRightHand = modelBipedMain.holdingRightHand = false;
-        modelArmorChestplate.holdingLeftHand = modelArmor.holdingLeftHand = modelBipedMain.holdingLeftHand = false;
-        GL11.glDisable(GL11.GL_BLEND);
+        super.render(tessellator, entity, x, y, z, yaw, partialTick);
     }
 
     @Override
     public void loadEntityTexture(Player entity) {
         bindDownloadableTexture(entity.skinURL, entity.getEntityTexture(), PlayerSkinParser.instance);
     }
-
-    @Override
-    protected float limbSway(Player entity, float partialTick)
-    {
-        return super.limbSway(entity, partialTick);
-    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
index fdc7a9ff0..3a87550ae 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.item.model;
 
 import net.minecraft.client.util.dispatch.Dispatcher;
+import net.minecraft.core.Global;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
@@ -229,6 +230,13 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
         addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.PORTAL_PARADISE.asItem()).setFullBright());
         addDispatch(new ItemModelBlock((ItemBlock<?>) Blocks.PORTAL_NETHER.asItem()).setFullBright());
 
+        addDispatch(new ItemModelStandard(Items.JAR_BUTTERFLY_BLUE, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.JAR_BUTTERFLY_ORANGE, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.JAR_BUTTERFLY_PINK, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.JAR_BUTTERFLY_SILVER, "minecraft"));
+
+        addDispatch(new ItemModelStandard(Items.STATUE_STONE, "minecraft"));
+
         for (int i = 0; i < Blocks.blocksList.length; i++) {
             if (Blocks.blocksList[i] == null) continue;
             Item item = Blocks.blocksList[i].asItem();
@@ -236,5 +244,12 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
             if (!(item instanceof ItemBlock)) continue;
             addDispatch(new ItemModelBlock((ItemBlock<?>) item));
         }
+
+        if (Global.ASSERTIONS_ENABLED) {
+            for (Item item : Item.itemsList) {
+                if (item == null) continue;
+                assert dispatches.containsKey(item) : "Item '" + item.namespaceID + "' was not assigned an item model!";
+            }
+        }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/Shaders.java b/game/client/src/main/java/net/minecraft/client/render/shader/Shaders.java
index f70129a94..732d52dd4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/shader/Shaders.java
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/Shaders.java
@@ -8,6 +8,7 @@ import net.minecraft.client.gui.ScreenPhotoMode;
 import net.minecraft.client.render.camera.CameraUtil;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.ItemStack;
 
@@ -76,7 +77,7 @@ public abstract class Shaders {
 		shader.uniformInt("dimension", minecraft.currentWorld != null && minecraft.currentWorld.dimension != null ? minecraft.currentWorld.dimension.id : 0);
 		shader.uniformInt("cbCorrectionMode", minecraft.gameSettings.colorblindnessFix.value.ordinal());
 
-		ItemStack helmet = minecraft.thePlayer == null ? null : minecraft.thePlayer.inventory.armorItemInSlot(IArmorItem.PIECE_HEAD);
+		ItemStack helmet = minecraft.thePlayer == null ? null : minecraft.thePlayer.getItemInArmorSlot(HumanArmorShape.HEAD);
 		shader.uniformInt("shaderEffect", helmet != null && helmet.itemID == Blocks.PUMPKIN_REDSTONE.id() ? 1 : 0);
 
 		int isEyeInLiquid = 0;
